/*   		AT90S8535
  ICP (Input Capture Pint     )   , 
           , 
    .    AT90S8535.*/

#include  <avr/io.h>
#include  <avr/interrupt.h>     	//          sei()
#include  <avr/signal.h>			//          INTERRUPT

unsigned  char  OverflowC;			//         /1
unsigned  int  EdgeR,   EdgeF;		//                  
unsigned  long  PulseClocks;      //     ,               ICP

ISR(TIMER1_OVF_vect)			//       /1
{
	OverflowC++;   					//   
	INTERRUPT (SIG_INPUT_CAPTURE1 ) //     {
	if ((PIND & 0x40) != 0)  		//      D - 
	{	//,...
		EdgeR = ICR1;      			//     
		TCCR1B = TCCR1B & 0xBF;  	//         ICP
		OverflowC = 0;				//   
	}
	else  							//      D -   
	{
		EdgeF = ICR1;       			//     
		TCCR1B = TCCR1B | 0x40;  		//         ICP
		//       ICP PulseClocks = (unsigned long)EdgeF -
		(unsigned long)EdgeR + (unsigned long)OverflowC * 0x10000; 
		PORTC = PulseClocks / 500;  //   .
	}
}
 
int main (void) 
{
	DDRC = OxFF;  				//    - 
	TCCR1B = 0xC2;				/*       /1 = 8; 
								          ICP.*/
	TIMSK = 0x24; 				//          /1 */
	sei () ;					//  
	while(1) ;					//      /1
}
 

 
